<?php
/* Functions */

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
if (!defined('IN_ADMIN') or !IN_ADMIN) die('Hacking attempt!');

// Select the correct menu on loc_end_admin
function whois_select_menu() {
	global $conf_whois, $template;
	if ($conf_whois['Add icon to History'] or !$conf_whois['Add to Plugins menu']) 
		$template->assign('ACTIVE_MENU', 4);
	else $template->assign('ACTIVE_MENU', 3);
}

// Template function
function Whois_most($text, $count, $when, $format) {
 return sprintf(l10n($text),$count,date(l10n($format),$when));
}

function whois_country($trace, $bypass = false)
{
  global $conf;
  
  if (!isset($trace['country'])) {
			pwg_query('ALTER TABLE ' . WHOIS_ONLINE_TABLE . ' ADD `country` VARCHAR( 254 ) NOT NULL AFTER `lang` ;');
			$trace['country']='';
	}
	$c = array();
	if ($trace['country']!='') $c = @unserialize(htmlspecialchars_decode($trace['country']));
	if (isset($c['Code']) and $c['Code']!='' and $c['Code']!='__') return $c; 
	if ($bypass and isset($c['Code'])) return $c;

  $c = array(
    'Code' => '__',
    'Name' => l10n('Unknown country'),
    'City' => 'N/A',
    );

  if (!filter_var($trace['IP'], FILTER_VALIDATE_IP))
  {
    return $c;
  }
      
  if (isset($conf['whois_online_use_geoiplookup']) and $conf['whois_online_use_geoiplookup'])
  {
    $geoiplookup_output = exec('geoiplookup '.$trace['IP']);

    if (!preg_match('/IP Address not found/', $geoiplookup_output))
    {
      list(,$geoiplookup_output) = explode(':', $geoiplookup_output);
      list($country_code, $country_name) = explode(',', $geoiplookup_output);

      $c['Name'] = trim($country_name);
      $c['Code'] = trim($country_code);
    }
  }
  else
  {
    $url = 'http://freegeoip.net/json/' . $trace['IP'];
  
    if (fetchRemote($url, $result) and $geo_data = @json_decode($result, true))
    {
      // echo '<pre>'; print_r($geo_data); echo '</pre>';
      $c['Name'] = $geo_data['country_name'];
      $c['Code'] = $geo_data['country_code'];
    }
  }

  $new = htmlspecialchars(serialize($c),ENT_QUOTES,'UTF-8');
  
	if ($new == $trace['country']) return $c;
  
	pwg_query('
UPDATE ' . WHOIS_ONLINE_TABLE . ' 
  SET `country` = \'' . $new . '\'
  WHERE `session_id` = \'' . $trace['session_id'] . '\'
;');
  
  return $c;
}

function whois_flag($trace, &$step, $limit = 10) {
	$flag = WHOIS_ONLINE_PATH . 'flags/' . $trace['Country']['Code'] . '.jpg';
	if (file_exists($flag) and  $trace['Country']['Code'] != '__' ) return $flag;
	if ($trace['Country']['Code'] == '__' ) {
	    $flag = WHOIS_ONLINE_PATH . 'flags/' . substr($trace['lang'],-2, 2) . '.jpg';
		if (file_exists($flag)) return $flag;
		return WHOIS_ONLINE_PATH . 'flags/__.jpg';
	}
	if ( $step > $limit ) return WHOIS_ONLINE_PATH . 'flags/.jpg';
	$f = fopen  ('http://api.hostip.info/flag.php?ip=' . $trace['IP'], 'r');
	$result='';
	while ($l = fgets ($f, 1024)) $result .= $l;
	fclose ($f);
	$f = fopen($flag,"w+");
	fputs($f,$result);
	fclose($f);
	return $flag;
}

/*
  returns (mixed): (string) 'bot agent name'  || (bool) false
  @param (string) HTTP_USER_AGENT
*/
function is_a_bot($agent = '') 
{
  global $conf;
	if ($agent == '') $agent = $_SERVER['HTTP_USER_AGENT'];
	$botlist = array('Teoma', 'alexa', 'froogle', 'Gigabot', 'inktomi',
	'looksmart', 'URL_Spider_SQL', 'Firefly', 'NationalDirectory', 
	'Ask Jeeves', 'TECNOSEEK', 'InfoSeek', 'WebFindBot', 'girafabot',
	'crawler', 'www.galaxy.com', 'Googlebot', 'Scooter', 'Slurp',
	'msnbot', 'appie', 'FAST', 'WebBug', 'Spade', 'ZyBorg', 'rabaz',
	'Baiduspider', 'Feedfetcher-Google', 'TechnoratiSnoop', 'Rankivabot',
	'Mediapartners-Google', 'Sogou web spider', 'WebAlta Crawler');
  if (isset($conf['search_agents']))
	  $botlist = array_merge( $botlist, array_diff( $conf['search_agents'], $botlist ) );
  foreach($botlist as $bot) {
    if (stripos($agent, $bot)!==false) return $bot; 
  }
  return false;
} 
?>